// Copyright (C) 2006-2011 Xilinx, Inc.  All rights reserved
// $Id: PinGroup.c,v 1.16 2011/03/04 02:05:29 jcorbett Exp $
#include "PinGroup.h"

#include "main.h"

// required for Port Utilities
static const char modname[] = __FILE__;
static const char rcsrev[] = "$Revision: 1.16 $";

// R#check_package_pins, R#report_io_assignments
PinGroup::PinGroup(std::string pin,
                   std::string net,
                   std::string group,
                   PinFaultList& pinFaultList,
                   int iobank)
  : pinName(pin),
    netName(net),
    group(group),
    iobank(iobank),
    faults(pinFaultList)
{}

// Collect neighbors when isolation groups differ.
void PinGroup::Visit(PinGroup* adjoined) {
   if (!adjoined) {             // R#report_errors
      FatalInternal(27, "PinGroup::Visit() called on null.");
   }
   if (group != adjoined->group
       && group != "ignored"
       && group != "combined"
       && adjoined->group != "ignored"
       && adjoined->group != "combined")
   {
      faults.push_back(std::make_pair(this, adjoined));
   }
}
